/* eSchemes Deluxe Installation Procedure */

/* 㦠 SysUtils */
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs

/* ।塞 ⥬ ⠫  ᪨ */

/* ६ ⠫ */
temp = STRIP(VALUE('TEMP',,'OS2ENVIRONMENT'))
if temp='' then
do
  temp = STRIP(VALUE('TMP',,'OS2ENVIRONMENT'))
  if temp='' then
  do
    errmsg='Environment variable TEMP or TMP not set.'
    signal error
  end
end

/* ⠫  樮 */
osdir = STRIP(VALUE('OSDIR',,'OS2ENVIRONMENT'))
if osdir='' then
do
  say 'IBM OS/2 or eComStation 1.0 detected'
  OS="OS2"
  If \Rxfuncquery('SysBootDrive') Then
  do
    bootdrive = SysBootDrive()
  end
  else
  do
    parse upper value VALUE( "PATH",, "OS2ENVIRONMENT" ) with "\OS2\SYSTEM" -2, bootdrive +2
    if bootdrive = '' then
    do
      errmsg='Can not detect boot drive. Please update REXXUTIL.DLL.'
      signal error
    end
  end
  osdir=bootdrive||'\OS2'
end
else
do
  say 'eComStation 1.1 or higher detected'
  OS="ECS"
end

c = SUBSTR(osdir, 1, 1)
backdir = osdir||'\INSTALL\BACKUP'
'@if not exist '||backdir||' md '||backdir
backdir = osdir||'\INSTALL\BACKUP\ESCHEMES'
'@if not exist '||backdir||' md '||backdir
backdir = osdir||'\INSTALL\BACKUP\ESCHEMES\'||DATE('S')||TIME('S')
'@if not exist '||backdir||' md '||backdir

/* ।塞 ⠫  㬥 */
mmbase = STRIP(VALUE('MMBASE',,'OS2ENVIRONMENT'))
parse value mmbase with mmbase ';'

if mmbase='' then mmbase=c||':\MMOS2'

/*  ᯨ᮪ 䠩,  㤥 ⠭ */
tmp=temp||'\deluxe.tmp'
tmp2=temp||'\deluxe2.cmd'
'@dir /b *.dll  > '||tmp

/* 塞,   ࠥ */
do while lines(tmp)>0
  s=linein(tmp)
  mmdir=mmbase||'DLL\'
  rc=lineout(tmp2,'@if exist "'||mmdir||s||'" copy "'||mmdir||s||'" "'||backdir||'\'||s||'" > nul')
end
rc=stream(tmp2,'c','close')

/*  १ࢭ  */
'@call '||tmp2
'@del '||tmp2

/*  ஢  祭 䠩 */
/* !!!  襭  OS/2 !!! */
if OS="ECS" then
do
  '@unlock '||mmbase||'\dll\*io.dll >nul'
  '@unlock '||mmbase||'\dll\zcodec.dll >nul'
  '@unlock '||osdir||'\dll\wpimgex.dll >nul'
  '@unlock '||osdir||'\dll\wpobjex.dll >nul'
  '@unlock '||osdir||'\dll\wpfldrex.dll >nul'
end

/* ।塞,   MINSTALL    ⥬ */
'@bldlevel '||mmbase||'\minstall.exe > rep'
tmp='rep'
do while lines(tmp)>0
  s=linein(tmp)
  parse value s with Key ':' Value
  If strip(key)='Vendor' then leave
end

rc=stream('rep','c','close')
'@del rep'

z=directory();
curdir=''
do p=1 to length(z)
  l=substr(z, p, 1)
  if l='\' then
    curdir=curdir||'\\'
  else
    curdir=curdir||l
end

mmdir=''
if substr(mmbase, length(mmbase))='\' then mmbase=substr(mmbase, 1, length(mmbase)-1)
do p=1 to length(mmbase)
  l=substr(mmbase, p, 1)
  if l='\' then
    mmdir=mmdir||'\\'
  else
    mmdir=mmdir||l
end

/* 㥬 䠩 ⢥⮢ */

/* ந⥫ - KIEWITZ*/
if strip(value)='KIEWITZ' then
do
Say 'MINSTALL by KIEWITZ'
rc=lineout('rep', 'MMINSTALL = ( ')
rc=lineout('rep', '   SOURCE = "'||curdir||'"')
rc=lineout('rep', '   TARGET = "'||mmdir||'"')
rc=lineout('rep', '   TARGETBOOT = ""')
rc=lineout('rep', '   GROUPS[22] = (')
rc=lineout('rep', '      ( GROUPID    = 1')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 2')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 3')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 5')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 6')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 7')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 8')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 9')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 10')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 11')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 12')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 13')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 14')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 15')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 16')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 17')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 18')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 19')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 21')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 22')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 23')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '      ( GROUPID    = 24')
rc=lineout('rep', '        CUSTOMDATA = ""')
rc=lineout('rep', '      )')
rc=lineout('rep', '    )')
rc=lineout('rep', ' )')
end
else
/* ந⥫ - IBM */
if strip(value)='IBM' then
do
Say 'MINSTALL by IBM'
rc=lineout('rep', 'MMINSTSOURCE = "'||curdir||'"')
rc=lineout('rep', 'MMINSTTARGET = "'||c||':"')
rc=lineout('rep', 'CHANGECONFIG = "Y"')
rc=lineout('rep', '')
rc=lineout('rep', 'MMINSTGROUPS =')
rc=lineout('rep', '   (')
rc=lineout('rep', '   GROUP.1 = " "')
rc=lineout('rep', '   GROUP.2 = " "')
rc=lineout('rep', '   GROUP.3 = " "')
rc=lineout('rep', '   GROUP.5 = " "')
rc=lineout('rep', '   GROUP.6 = " "')
rc=lineout('rep', '   GROUP.7 = " "')
rc=lineout('rep', '   GROUP.8 = " "')
rc=lineout('rep', '   GROUP.9 = " "')
rc=lineout('rep', '   GROUP.10 = " "')
rc=lineout('rep', '   GROUP.11 = " "')
rc=lineout('rep', '   GROUP.12 = " "')
rc=lineout('rep', '   GROUP.13 = " "')
rc=lineout('rep', '   GROUP.14 = " "')
rc=lineout('rep', '   GROUP.15 = " "')
rc=lineout('rep', '   GROUP.16 = " "')
rc=lineout('rep', '   GROUP.17 = " "')
rc=lineout('rep', '   GROUP.18 = " "')
rc=lineout('rep', '   GROUP.19 = " "')
rc=lineout('rep', '   GROUP.20 = " "')
rc=lineout('rep', '   GROUP.21 = " "')
rc=lineout('rep', '   GROUP.22 = " "')
rc=lineout('rep', '   GROUP.23 = " "')
rc=lineout('rep', '   GROUP.24 = " "')
rc=lineout('rep', '   )')
end
else
  Say 'Error! Unknown MINSTALL version'

rc=stream('rep','c','close')

/* 뢠 楤 ⠭ */
'@minstall /R:rep /F:'||directory()||'\control.scr > nul'
if RC<>-512 then
do
  errmsg='Error during MINSTALL. RC='||RC
  signal error
end

'@del rep'
say 'I/O Procedures installed'

/*  窠  , 祣 MINSTALL  㬥  㬥 筮. */
if SysRegisterObjectClass("WPObjectEx","WPOBJEX") then
  say 'WPObjectEx Class Registered'
else
  say 'Error registering WPObjectEx Class'

if SysRegisterObjectClass("WPImageFileEx","WPIMGEX") then
  say 'WPImageFileEx Class Registered'
else
  say 'Error registering WPImageFileEx Class'

if SysRegisterObjectClass("WPFolderEx","WPFLDREX") then
  say 'WPFolderEx Class Registered'
else
  say 'Error registering WPFolderEx Class'


if SysIni(USER, "PM_InstallClassReplacement", 'WPObject', 'WPObjectEx') = '' then
  say 'WPObject class replaced by WPObjectEx'
else
  say 'WPObject class replacement error'

if SysIni(USER, "PM_InstallClassReplacement", 'WPImageFile', 'WPImageFileEx') = '' then
  say 'WPImageFile class replaced by WPImageFileEx'
else
  say 'WPImageFile class replacement error'

if SysIni(USER, "PM_InstallClassReplacement", 'WPFolder', 'WPFolderEx') = '' then
  say 'WPFolder class replaced by WPFolderEx'
else
  say 'WPFolder class replacement error'

'@copy uninstall.cmd '||osdir||'\INSTALL\BACKUP\ESCHEMES > nul'
If SysCreateObject("WPProgram", "eSchemes Deluxe deinstallation", "<WP_ASDUNINSTFOLDER>","EXENAME="||osdir||"\INSTALL\BACKUP\ESCHEMES\uninstall.cmd;OBJECTID=<123>","U") Then
Say 'Deinstallation procedure installed'

/* .  ⮢. */
say ''
say 'Installation finished. Please reboot.'

return

error:
  say errmsg
exit
